
#ifndef CSOUND_MIDIDEFS_H
#define CSOUND_MIDIDEFS_H

#define NOTEOFF_TYPE  0x80
#define NOTEON_TYPE   0x90
#define POLYAFT_TYPE  0xA0
#define CONTROL_TYPE  0xB0
#define PROGRAM_TYPE  0xC0
#define AFTOUCH_TYPE  0xD0
#define PCHBEND_TYPE  0xE0
#define SYSTEM_TYPE   0xF0

#define DATENABL        3       /* unused ctl_val spc */
#define DATENTRY        6
#define VOLUME          7
#define MOD_VOLUME      9       /* unused ctl_val spc */
#define SUSTAIN_SW      64
#define NRPNLSB         98
#define NRPNMSB         99
#define RPNLSB          100
#define RPNMSB          101

#define VIB_RATE        102     /* ROLAND EXTENDED CTRLS */
#define VIB_DEPTH       103     /* in unused ctl_val spc */
#define VIB_DELAY       104
#define TVF_CUTOFF      105
#define TVF_RESON       106
#define TVA_RIS         107
#define TVA_DEC         108
#define TVA_RLS         109

#define BENDSENS        110     /* unused ctl_val spc */

typedef struct {
    short  type;
    short  chan;
    short  dat1;
    short  dat2;
} MEVENT;

typedef union {
    unsigned long dwData;
    unsigned char bData[4];
} MIDIMESSAGE;

extern  MEVENT  *Midevtblk, *FMidevtblk;
extern  long    FMidiNxtk;

void    m_chinsno(short, short);
MCHNBLK *m_getchnl(MYFLT*);             /* IV - Feb 18 2003 */
void    m_chn_init(MEVENT*, short);
void    midNotesOff(void);

int     sensMidi(void);
int     sensFMidi(void);

void    OpenMIDIDevice(void);
void    CloseMIDIDevice(void);

#define MBUFSIZ   (1024)
#define MBUFMSK   (MBUFSIZ - 1)

#define MIDIINBUFMAX    (1024)
#define MIDIINBUFMSK    (MIDIINBUFMAX - 1)

#endif

