/* ***************************************************************** */
/* ******** Program to export hetro files in tabular format. ******* */
/* ***************************************************************** */

/* ***************************************************************** */
/* John ffitch 1995 Jun 19                                           */
/* ***************************************************************** */

#include <stdio.h>
#include <stdarg.h>

#include <cs.h>

#define END  32767

static void usage(void);

int main(int argc, char **argv)
{
    MEMFIL *inf;
    FILE *outf;
    short *adp;
    short *endata;
    int cc = 0;

    globals_init((void*) &cglob);

    if (argc!= 3)
        usage();
    inf = ldmemfile(argv[1]);
    if (inf == NULL) {
        fprintf(stderr, "Cannot open input file %s\n", argv[1]);
        exit(1);
    }
    outf = fopen(argv[2], "w");
    if (inf == NULL) {
        fprintf(stderr, "Cannot open output file %s\n", argv[2]);
        exit(1);
    }
    adp = (short *) inf->beginp;
    endata = (short *) inf->endp;
    cc = 0;
    if (*adp > 0) fprintf(outf, "%d\n", *adp++);
    for (; adp<endata; adp++) {
        if (*adp == END) fputc('\n',outf), cc = 0;
        else fprintf(outf, "%s%hd", (cc ? ",":""), *adp), cc = 1;
    }
    fclose(outf);
    return 0;
}

static void usage(void)
{
    err_printf("usage: het_export <infile> <outfile>\n");
    exit(1);
}

